{% extends "app/history.html" %}

{% block energy_actions %}

    {% load staticfiles %}
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-table.min.css' %}"/>
    {% csrf_token %}
    {% if actor == None %}
        <h3>You have not been mapped to a known Market Actor. Please contact the Marketplace administrator.</h3>
    {% else %}

             {% if request.session.actor.marketActorTypeid.type == "market operator" %}
            <h3>Actions overview</h3>
        {% else %}
            <h3>Previous actions of {{ actor.representativeName }}</h3>
        {% endif %}
        <h3>
            <small>Electricity actions</small>
        </h3>

        <table id="energy_actions_table"
               data-toggle="table"
               class="table"
               data-pagination="true"
               data-search="true"
               data-page-list="[10, 25, 50, 100, ALL]"
               data-sort-name="date"
               data-halign="center"
               data-sort-order="desc"
               data-click-to-select="true"
               data-single-select="true"
               data-show-export="true">
            <thead>
            <tr>
                <th data-field="id"  class="th th-inner" data-sortable="true" data-visible="true" >ID</th>

                 {% if request.session.actor.marketActorTypeid.type == "market operator"%}
                    <th class="th th-inner" data-sortable="true" data-field="participant" data-visible="true">
                        Participant
                    </th>
                {% endif %}

                <th class="th th-inner" data-sortable="true" data-field="timeframe" data-visible="true">Timeframe</th>
                <th class="th th-inner" data-sortable="true" data-field="marketSession" data-formatter="setMarketSessionFormatter" data-visible="true">Market session</th>
                <th class="th th-inner" data-sortable="true" data-field="id" data-visible="false"> Name</th>
                <th class="th th-inner" data-sortable="true" data-field="date" data-align="center">Date</th>
                <th class="th th-inner" data-sortable="true" data-field="actionStartTime" data-align="center">
                    Action<br/>Start Time
                </th>
                <th class="th th-inner" data-sortable="true" data-field="actionEndTime" data-align="center">Action<br>End
                    Time
                </th>
                <th class="th th-inner" data-sortable="true" data-field="value" data-align="center" data-formatter="europeanNumberFormatter">Quantity (MWh)</th>
                <th class="th th-inner" data-sortable="true" data-field="price" data-align="center" data-formatter="europeanNumberFormatter">Price<br>(&#8364;/MWh)
                </th>
                <th class="th th-inner" data-sortable="true" data-field="actionType" data-align="center"
                    data-formatter="setActionTypeFormatter">Type
                </th>
                <th class="th th-inner" data-sortable="true" data-field="deliveryPoint" data-align="center">Delivery
                    Point
                </th>
                <th class="th th-inner" data-sortable="true" data-field="actionStatus" data-align="center"
                    data-formatter="setActionStatusFormatter">Status
                </th>
                <th class="th th-inner" data-sortable="true" data-align="center" data-field="clearingPrice">Clearing
                    Price<br>(&#8364;/MWh)
                </th>
                <th class="th th-inner" data-sortable="true" data-align="center" data-field="amount">Accepted Quantity (MWh)
                </th>
            </tr>
            </thead>
        </table>

    {% endif %}
{% endblock %}

{% block scripts %}
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-table.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/moment.min.js' %}"></script>
    <script type="text/javascript"
            src="{% static 'app/scripts/bootstrap-table/extensions/export/bootstrap-table-export.min.js' %}"></script>
    <script type="text/javascript"
            src="{% static 'app/scripts/bootstrap-table/extensions/export/tableExport.js' %}"></script>
   <script type="text/javascript" src="{% static 'app/scripts/admin/displayMarketSessionInfo.js' %}"></script>
   <script type="text/javascript" src="{% static 'app/scripts/date_utils/date_utils.js' %}"></script>
   <script type="text/javascript" src="{% static 'app/scripts/utilities.js' %}"></script>

    <script type="text/javascript">
        var d = [];
        var token = "{{ token }}";
        var username = "{{username}}";
        var ENERGY_HISTORY_URL = "{{ ENERGY_HISTORY_URL }}";
        var ACTION_STATUS_URL = "{{ ACTION_STATUS_URL }}";
        var MARKETSESSION_URL = "{{ MARKETSESSION_URL }}";
        var form = "{{ ELECTRIC }}";
        var registeredMarket = getUserRegisteredMarketByForm(user_markets, form);

        console.log(registeredMarket.url + ENERGY_HISTORY_URL +username+'/',"");


        $(document).ready(function () {
            $(".vertical_tab").removeClass("active");
            $(".tab-pane").removeClass("active");
            $("#energy_tab").addClass("active");
            $("#energy_history").addClass("active");
            $.ajax({
                url: registeredMarket.url + ENERGY_HISTORY_URL +username+'/',
                type: 'GET',
                dataType: 'json',
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", token)
                },
                success: function (data) {

                    console.log("Actions:");
                    console.log(data);
                    var actions = data['actions'];
                    var clearing_info = data['clearing_info'];
                    for (var i in actions) {
                        var clearingPrice;
                        var amount;
                        if ((actions[i].statusid.status != "accepted") && (actions[i].statusid.status != "partially_accepted")) {
                            clearingPrice = "N/A";
                            amount = "N/A";
                        } else {
                            for (var info in clearing_info) {
                                if (clearing_info[info].id == actions[i].id) {
                                    clearingPrice = parseFloat(clearing_info[info].clearing_price).toFixed(2).toString().replace("." , ",");
                                    amount = parseFloat(clearing_info[info].value).toFixed(3).toString().replace("." , ",");
                                }
                            }
                        }

                        var timeFormatStr = "YYYY-MM-DD HH:mm +SSSS";
                        d.push({
                            id: actions[i].id,
                            participant: actions[i].marketActorid.representativeName,
                            date: moment.utc(actions[i].date).format(timeFormatStr),
                            actionStartTime: moment.utc(actions[i].actionStartTime).format(timeFormatStr),
                            actionEndTime: moment.utc(actions[i].actionEndTime).format(timeFormatStr),
                            value: parseFloat(actions[i].value).toFixed(3).toString(),
                            price: parseFloat(actions[i].price).toFixed(2),
                            actionType: actions[i].actionTypeid.type,
                            deliveryPoint: actions[i].deliveryPoint,
                            actionStatus: actions[i].statusid.id,
                            clearingPrice: clearingPrice,
                            amount: amount,
                            marketSession: actions[i].marketSessionid.id,
                            timeframe: actions[i].marketSessionid.marketplaceid.marketServiceTypeid.timeFrameid.type.replace("_", " ")
                        });
                    }
                    var table = $("#energy_actions_table").bootstrapTable();
                    {#$("#energy_actions_table").bootstrapTable('destroy');#}
                    $("#energy_actions_table").bootstrapTable('load', d);
                    $('.fixed-table-body').css('height', 'auto').css('max-width', '100%');
                }
            });
        }).on('all.bs.table', "#energy_actions_table", function (name, args) {
            $("td").each(function () {
                $(this).css('vertical-align', 'middle').css('font-size', '11pt');
            });
            $("th").css('vertical-align', 'middle');
        });

        function setActionTypeFormatter(value, row, index) {
            if (value == "bid") {
                return '<div style="color:green;">Bid</div>';
            }
            return '<div style="color:red;">Offer</div>';
        }

        function setActionStatusFormatter(value, row, index) {
            return ActionStatus.formatter(value);
        }

    </script>
{% endblock %}



